searchData={"items":[{"type":"module","title":"EctoCursor","doc":"Documentation for `EctoCursor`.\n\nThis is a fully automatic cursor based pagination for Ecto.\nIt requires zero configuraion and is aiming to support arbitrary queries:\njoins, grouppings with aggregates, etc. Currently absolute support is not guaranteed,\nas this library is still under development (I appreciate issues).","ref":"EctoCursor.html"},{"type":"module","title":"Usage - EctoCursor","doc":"defmodule YourApp.Repo do\n      use Ecto.Repo,\n        otp_app: :your_app,\n        adapter: Ecto.Adapters.Postgres\n      use EctoCursor\n    end\n\nThis adds function `paginate` to the Repo:\n\n    params = %{cursor: str limit: int max_limit: int}\n    %Page{entries: [...], cursor: next} = Repo.paginate(query, params)\n\nAll parameters are optional, `max_limit` is used to trim client passed limit.\nMissing cursor means the beginning of the stream.","ref":"EctoCursor.html#module-usage"},{"type":"module","title":"Validation of cursor - EctoCursor","doc":"Cursor produced by the query is signed and supposed to work\nwith the query with exactly the same ordering. Invalid cursor will be simply ignored.","ref":"EctoCursor.html#module-validation-of-cursor"},{"type":"module","title":"Generation of cursor - EctoCursor","doc":"Unlike very first version, where cursor was generated with a separate request,\nnow it's all happening in one call. This might break with some complex expressions in select clause.\nPlease report if it's broken for you.","ref":"EctoCursor.html#module-generation-of-cursor"},{"type":"function","title":"EctoCursor.append_cursor/2","doc":"Injecting next cursor components into the query. This is done by wrapping original (or default)\nselect into the tuple `select({original_select, {componen1, component2, ...}})` and potentiall\ncan mess up complex queries.","ref":"EctoCursor.html#append_cursor/2"},{"type":"function","title":"EctoCursor.augument_query/2","doc":"Applying condition from the cursor to the query.\nThis includes generating additional `where` or `having` clauses and applying a limit.","ref":"EctoCursor.html#augument_query/2"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}